"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Field = void 0;
const react_1 = __importDefault(require("react"));
const react_hook_form_1 = require("react-hook-form");
const Checkbox_1 = require("@procyon/components/Checkbox");
const DatePicker_1 = require("@procyon/components/DatePicker");
const RadioButton_1 = require("@procyon/components/RadioButton");
const Selectbox_1 = require("@procyon/components/Selectbox/Selectbox");
const TextField_1 = require("@procyon/components/TextField");
const TimePicker_1 = require("@procyon/components/TimePicker");
const Field = (_a) => {
    var props = __rest(_a, []);
    const { control } = (0, react_hook_form_1.useFormContext)();
    const { field, fieldState } = (0, react_hook_form_1.useController)({ name: props.name, control });
    switch (props.component) {
        case 'TEXT':
            return (react_1.default.createElement(TextField_1.TextField, Object.assign({}, props, { value: field.value }, (fieldState.error && {
                message: fieldState.error.message,
                color: 'negative',
            }), { onChange: (e, value) => field.onChange(value), onBlur: field.onBlur })));
        case 'CHECK':
            return (react_1.default.createElement(Checkbox_1.Checkbox, Object.assign({}, props, (fieldState.error && {
                message: fieldState.error.message,
                color: 'negative',
            }), { checked: field.value, onChange: (e, checked) => field.onChange(checked) })));
        case 'RADIO':
            return (react_1.default.createElement(RadioButton_1.RadioButton, Object.assign({}, props, { value: field.value }, (fieldState.error && {
                message: fieldState.error.message,
                color: 'negative',
            }), { onChange: (e, value) => field.onChange(value) }), props.children));
        case 'SELECT':
            return (react_1.default.createElement(Selectbox_1.Selectbox, Object.assign({}, props, { value: field.value }, (fieldState.error && {
                message: fieldState.error.message,
                color: 'negative',
            }), { onChange: (e, value) => field.onChange(value) })));
        case 'DATE':
            return (react_1.default.createElement(DatePicker_1.DatePicker, Object.assign({}, props, { value: field.value }, (fieldState.error && {
                message: fieldState.error.message,
                color: 'negative',
            }), { onChange: (e, value) => field.onChange(value) })));
        case 'TIME':
            return (react_1.default.createElement(TimePicker_1.TimePicker, Object.assign({}, props, { value: field.value }, (fieldState.error && {
                message: fieldState.error.message,
                color: 'negative',
            }), { onChange: (e, value) => field.onChange(value) })));
        default:
            return null;
    }
};
exports.Field = Field;
